Gecode::TupleSet::Data Class Reference

Data stored for a Table. More...

`#include <int.hh>`

## Public Member Functions

Tuple | add (void)
| Return newly added tuple.
Tuple | get (int i) const
| Return tuple with number i.
unsigned int | tuple2idx (Tuple t) const
| Map tuple address to index.
const Range * | fst (int i) const
| Return first range for position i.
const Range * | lst (int i) const
| Return last range for position i.
void | finalize (void)
| Finalize datastructure (disallows additions of more Tuples).
void | resize (void)
| Resize tuple data.
bool | finalized (void) const
| Is datastructure finalized.
| Data (int a)
| Initialize as empty tuple set with arity a.
virtual | ~Data (void)
| Delete implementation.
Public Member Functions inherited from Gecode::SharedHandle::Object
| Object (void)
| Initialize.
virtual | ~Object (void)
| Delete shared object.

## Static Public Member Functions

static void | set (BitSetData *d, unsigned int n)
| Set bit n in bitset data d.
static bool | get (const BitSetData *d, unsigned int n)
| Get bit n in bitset data d.
Static Public Member Functions inherited from Gecode::HeapAllocated
static void * | operator new (size_t s)
| Memory management.
static void | operator delete (void *p)
| Free memory allocated from heap.

## Public Attributes

int | arity
| Arity.
unsigned int | n_words
| Number of words for support.
int | n_tuples
| Number of Tuples.
int | n_free
| Number of free tuple entries of arity.
int | min
| Smallest value.
int | max
| Largest value.
std::size_t | key
| Hash key.
int * | td
| Tuple data.
ValueData * | vd
| Value data.
Range * | range
| Pointer to all ranges.
BitSetData * | support
| Pointer to all support data.

## Static Protected Attributes

static const int | n_initial_free = 1024
| Initial number of free tuples.

## Detailed Description

Data stored for a Table.

Definition at line 2229 of file int.hh.

## Constructor & Destructor Documentation

## Data()

Gecode::TupleSet::Data::Data | ( | int | a | ) |

inline

Initialize as empty tuple set with arity a.

Definition at line 61 of file tuple-set.hpp.

## ~Data()

Gecode::TupleSet::Data::~Data | ( | void |  | ) |

virtual

Delete implementation.

Definition at line 254 of file tuple-set.cpp.

## Member Function Documentation

## add()

TupleSet::Tuple Gecode::TupleSet::Data::add | ( | void |  | ) |

inline

Return newly added tuple.

Definition at line 76 of file tuple-set.hpp.

## get() [1/2]

TupleSet::Tuple Gecode::TupleSet::Data::get | ( | int | i | ) | const

inline

Return tuple with number i.

Definition at line 87 of file tuple-set.hpp.

## set()

void Gecode::TupleSet::Data::set | ( | BitSetData * | d,
|  | unsigned int | n )

inline static

Set bit n in bitset data d.

Definition at line 113 of file tuple-set.hpp.

## get() [2/2]

bool Gecode::TupleSet::Data::get | ( | const BitSetData * | d,
|  | unsigned int | n )

inline static

Get bit n in bitset data d.

Definition at line 118 of file tuple-set.hpp.

## tuple2idx()

unsigned int Gecode::TupleSet::Data::tuple2idx | ( | Tuple | t | ) | const

inline

Map tuple address to index.

Definition at line 123 of file tuple-set.hpp.

## fst()

const TupleSet::Range * Gecode::TupleSet::Data::fst | ( | int | i | ) | const

inline

Return first range for position i.

Definition at line 128 of file tuple-set.hpp.

## lst()

const TupleSet::Range * Gecode::TupleSet::Data::lst | ( | int | i | ) | const

inline

Return last range for position i.

Definition at line 132 of file tuple-set.hpp.

## finalize()

void Gecode::TupleSet::Data::finalize | ( | void |  | ) |

Finalize datastructure (disallows additions of more Tuples).

Definition at line 103 of file tuple-set.cpp.

## resize()

void Gecode::TupleSet::Data::resize | ( | void |  | ) |

Resize tuple data.

Definition at line 247 of file tuple-set.cpp.

## finalized()

bool Gecode::TupleSet::Data::finalized | ( | void |  | ) | const

inline

Is datastructure finalized.

Definition at line 71 of file tuple-set.hpp.

## Member Data Documentation

## n_initial_free

const int Gecode::TupleSet::Data::n_initial_free = 1024

static protected

Initial number of free tuples.

Definition at line 2232 of file int.hh.

## arity

int Gecode::TupleSet::Data::arity

Arity.

Definition at line 2235 of file int.hh.

## n_words

unsigned int Gecode::TupleSet::Data::n_words

Number of words for support.

Definition at line 2237 of file int.hh.

## n_tuples

int Gecode::TupleSet::Data::n_tuples

Number of Tuples.

Definition at line 2239 of file int.hh.

## n_free

int Gecode::TupleSet::Data::n_free

Number of free tuple entries of arity.

Definition at line 2241 of file int.hh.

## min

int Gecode::TupleSet::Data::min

Smallest value.

Definition at line 2243 of file int.hh.

## max

int Gecode::TupleSet::Data::max

Largest value.

Definition at line 2245 of file int.hh.

## key

std::size_t Gecode::TupleSet::Data::key

Hash key.

Definition at line 2247 of file int.hh.

## td

int* Gecode::TupleSet::Data::td

Tuple data.

Definition at line 2249 of file int.hh.

## vd

ValueData* Gecode::TupleSet::Data::vd

Value data.

Definition at line 2251 of file int.hh.

## range

Range* Gecode::TupleSet::Data::range

Pointer to all ranges.

Definition at line 2253 of file int.hh.

## support

BitSetData* Gecode::TupleSet::Data::support

Pointer to all support data.

Definition at line 2255 of file int.hh.

The documentation for this class was generated from the following files:

- gecode/int.hh
- gecode/int/extensional/tuple-set.cpp
- gecode/int/extensional/tuple-set.hpp